<?php
/*
	Copyright (C) 2007 Dustin Spicuzza <dustin@virtualroadside.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License at <http://www.gnu.org/licenses/>
	for more details.
*/

class OWSDNS implements iPlugin, iAnalysisPlugin{

	// this should return a unique ID identifying the plugin, should start with an alpha,
	// should use basename instead of just __FILE__ otherwise it could expose path information
	public function getPluginId();//{
		return 'p'. md5(basename(__FILE__) . get_class());
	}
	
	// returns an associative array describing the plugin
	public function getPluginInformation(){
	
		return array(
			
			'pluginName' => 'DNS Plugin Example',
			'aboutUrl' => 'http://www.virtualroadside.com/blog/',
			
			'author' => 'Dustin Spicuzza',
			'url' => 'http://www.virtualroadside.com/',
			
			'description' => 'Resolves the hostname of IP addresses given'
		);
	}
	
	// this function should return a set of arrays that define the dimensions
	// and attributes that this plugin defines. You should not specify an attribute
	// that another plugin defines. This is not website dependent.
	public function define_dimensions(){

		return array(
			'host' => array(
				'hostname' => attribute_defn('varchar',254,16)
			)
		);
	}
		
	public function InitializeAnalysis($website){
		return true;
	}

	public function preAnalysis($website,&$ids){
		return true;
	}

	public function getPrimaryNode($website, $dimension, $line){
		return show_error("Invalid dimension passed to plugin\"" . get_class() . "\"");
	}

	public function postAnalysis($website,&$ids){
		return true;
	}

	public function getAttributes($website, $dimension, $pnode){

		if ($dimension != 'host')
			return show_error("Invalid dimension passed to plugin\"" . get_class() . "\" in getAttributes!");
			
		// return the hostname
		return array('hostname' => gethostbyaddr($pnode));
	
	}
}

register_plugin('analysis',new OWSDNS());

?>